<?php
// +---------------------------------------------------------------------------+
// | DokuWiki Plugin 1.5.2                                                       |
// +---------------------------------------------------------------------------+
// | $Id                                                                      $|
// | DokuWiki plugin installation for geeklog                                 |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006-2008 by the following authors:                         |
// |                                                                           |
// | Mark R. Evans                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once '../../../lib-common.php';
require_once $_CONF['path'] . '/plugins/dokuwiki/functions.inc';


$pi_name = 'dokuwiki';                      // Plugin name  Must be 15 chars or less
$pi_version = '1.5.2';                      // Plugin Version
$gl_version = '1.4.1';                      // GL Version plugin for
$pi_url = 'http://www.geeklog.fr';          // Plugin Homepage

//
// Default data
// Insert table name and sql to insert default data for your plugin.
//
$DEFVALUES = array();

// Only let Root users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the DokuWiki install/uninstall page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock('Access Denied');
    $display .= 'Access Denied';
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

/**
* Puts the datastructures for this plugin into the geeklog database
*
* Note: Corresponding uninstall routine is in functions.inc
*
* @return   boolean True if successful False otherwise
*
*/
function plugin_install_dokuwiki() {
    global $pi_name, $pi_version, $gl_version, $pi_url, $NEWTABLE, $DEFVALUES, $NEWFEATURE;
    global $_TABLES, $_CONF, $_DB_dbms;

    COM_errorLog("Attempting to install the $pi_name Plugin",1);

    // Register the plugin with geeklog
    COM_errorLog("Registering $pi_name plugin with geeklog", 1);
    DB_delete($_TABLES['plugins'],'pi_name','dokuwiki');
    DB_query("INSERT INTO {$_TABLES['plugins']} (pi_name, pi_version, pi_gl_version, pi_homepage, pi_enabled) "
        . "VALUES ('$pi_name', '$pi_version', '$gl_version', '$pi_url', 1)");

    if (DB_error()) {
        COM_errorLog("Failure registering plugin with geeklog");
        plugin_uninstall_dokuwiki();
        return false;
        exit;
    }

    COM_errorLog("Succesfully installed the $pi_name Plugin!",1);

    return true;
}

/*
* Main Function
*/

$action = COM_applyFilter($_POST['action']);

$display = COM_siteHeader();
$T = new Template($_CONF['path'] . 'plugins/dokuwiki/templates');
$T->set_file('install', 'install.thtml');
$T->set_var('install_header', $LANG_DW00['install_header']);
$T->set_var('img',$_CONF['site_url'] . '/dokuwiki/dokuwiki.png');
$T->set_var('cgiurl', $_CONF['site_admin_url'] . '/plugins/dokuwiki/install.php');
$T->set_var('admin_url', $_CONF['site_url'] . '/dokuwiki/doku.php?do=admin&amp;id=start');

if ($action == 'install') {
    if (plugin_install_dokuwiki()) {
        $installMsg = $LANG_DW00['install_success'];
        $T->set_var('installmsg1',$installMsg);
    } else {
        $T->set_var('installmsg1',$LANG_DW00['install_failed']);
    }
} else if ($action == "uninstall") {
   plugin_uninstall_dokuwiki('installed');
   $T->set_var('installmsg1',$LANG_DW00['uninstall_msg']);
}

if (DB_count($_TABLES['plugins'], 'pi_name', 'dokuwiki') == 0) {
	// perform some sanity checks

    $errCount = 0;

	$T->set_block('install', 'CheckRow','CRow');

    if (! is_writable( $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'conf/' ) ) {
	    $T->set_var(array(
	    	'path'		=> $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'conf/',
	    	'status' 	=> 'is not writable by DokuWiki. You need to fix the permission settings of this directory!'
	    ));
	    $errCount++;
        $T->parse('CRow','CheckRow',true);
    }

    if (! is_writable( $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/' ) ) {
	    $T->set_var(array(
	    	'path'		=> $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/',
	    	'status' 	=> 'is not writable by DokuWiki. You need to fix the permission settings of this directory!'
	    ));
	    $errCount++;
        $T->parse('CRow','CheckRow',true);
    }
    if (! is_writable( $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/pages/' ) ) {
	    $T->set_var(array(
	    	'path'		=> $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/pages/',
	    	'status' 	=> 'is not writable by DokuWiki. You need to fix the permission settings of this directory!'
	    ));
	    $errCount++;
        $T->parse('CRow','CheckRow',true);
    }
    if (! is_writable( $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/attic/' ) ) {
	    $T->set_var(array(
	    	'path'		=> $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/attic/',
	    	'status' 	=> 'is not writable by DokuWiki. You need to fix the permission settings of this directory!'
	    ));
	    $errCount++;
        $T->parse('CRow','CheckRow',true);
    }
    if (! is_writable( $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/media/' ) ) {
	    $T->set_var(array(
	    	'path'		=> $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/media/',
	    	'status' 	=> 'is not writable by DokuWiki. You need to fix the permission settings of this directory!'
	    ));
	    $errCount++;
        $T->parse('CRow','CheckRow',true);
    }
    if (! is_writable( $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/meta/' ) ) {
	    $T->set_var(array(
	    	'path'		=> $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/meta',
	    	'status' 	=> 'is not writable by DokuWiki. You need to fix the permission settings of this directory!'
	    ));
	    $errCount++;
        $T->parse('CRow','CheckRow',true);
    }
    if (! is_writable( $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/cache/' ) ) {
	    $T->set_var(array(
	    	'path'		=> $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/cache/',
	    	'status' 	=> 'is not writable by DokuWiki. You need to fix the permission settings of this directory!'
	    ));
	    $errCount++;
        $T->parse('CRow','CheckRow',true);
    }
    if (! is_writable( $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/locks/' ) ) {
	    $T->set_var(array(
	    	'path'		=> $_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/locks/',
	    	'status' 	=> 'is not writable by DokuWiki. You need to fix the permission settings of this directory!'
	    ));
	    $errCount++;
        $T->parse('CRow','CheckRow',true);
    }

    $glversion = explode(".", VERSION);
    if ( ($glversion[0] < 1 || $glversion[1] < 1 ) && defined('VERSION')) {
	    $T->set_var(array(
	    	'path'		=> 'geeklog version is not v1.4.1 or above',
	    	'status' 	=> 'Please upgrade your site to the latest version of geeklog'
	    ));
	    $errCount++;
        $T->parse('CRow','CheckRow',true);
    }

    $T->set_var('installmsg2', $LANG_DW00['uninstalled']);
    $T->set_var('readme', $LANG_DW00['readme']);
    if ( $errCount < 1 ) {
        $T->set_var('btnmsg', $LANG_DW00['install']);
    }
    $T->set_var('action','install');

    $T->set_var(array(
        'lang_overview'     => $LANG_DW00['overview'],
        'install_doc'       => $LANG_DW00['installdoc'],
    ));
} else {
    echo COM_refresh($_CONF['site_url'] . $_DW_CONF['public_dir'] . 'index.php');
    exit;
}
$T->parse('output','install');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter(true);

echo $display;

?>