<?php
// +---------------------------------------------------------------------------+
// | Dokuwiki Integration for geeklog CMS                                     |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006-2008 by the following authors:                         |
// |                                                                           |
// | Mark R. Evans                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

// this file can't be used on its own
if (strpos ($_SERVER['PHP_SELF'], 'functions.inc') !== false)
{
    die ('This file can not be used on its own.');
}

/**
* Language file Include
*/
$langfile = $_CONF['path'] . 'plugins/dokuwiki/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile)) {
    include_once ($langfile);
} else {
    include_once ($_CONF['path'] . 'plugins/dokuwiki/language/english.php');
}

require_once($_CONF['path'] . 'plugins/dokuwiki/config.php');

if(!defined('DOKU_INC')) define('DOKU_INC',$_CONF['path_html'] . $_DW_CONF['public_dir']);


// set the language for the wiki

if (isset($_USER['language']) ) {
    $lang = $_USER['language'];
} else {
    $lang = $_CONF['language'];
}
$conf['lang'] = $_CONF['iso_lang'];

/**
* This will put an option for the plugin in the command and control block on moderation.php
*
* Add the plugin name, icon and link to the command and control block in moderation.php
*
* @return   array   Array containing (plugin name, admin url, url of plugin icon)
*
*/

function plugin_cclabel_dokuwiki() {
    global $_CONF, $_DW_CONF;

    if (SEC_inGroup('Root') ) {
        return array('DokuWiki',
            $_CONF['site_url'] . $_DW_CONF['public_dir'] . 'doku.php?do=admin&amp;id=start',
            $_CONF['site_url'] . $_DW_CONF['public_dir'] . 'dokuwiki.png');
    } else {
        return '';
    }
}

/**
  * Whats New Block API Support
  * Return the Headline and Byline for the new section in the Whatsnew Block
*/
function plugin_whatsnewsupported_dokuwiki() {
    global $_CONF, $_DW_CONF, $_USER, $LANG_DW00;

    if ( $_DW_CONF['enable_whats_new'] != 1 ) {
        return;
    }
    if ( (!isset($_USER['uid']) || $_USER['uid'] < 2) && $_DW_CONF['loginrequired'] == 1 )  {
        return '';
    }

    if ($_DW_CONF['restrict_to_group'] != '' ) {
        if (SEC_inGroup($_DW_CONF['restrict_to_group'])) {
            $label = sprintf($LANG_DW00['whats_new_time'],$_DW_CONF['whats_new_days']);
            return array($LANG_DW00['whats_new_prompt'],$label);
        }
    } else {
        $label = sprintf($LANG_DW00['whats_new_time'],$_DW_CONF['whats_new_days']);
        return array($LANG_DW00['whats_new_prompt'],$label);
    }
    return '';
}

function plugin_getwhatsnew_dokuwiki() {
    global $conf;
    global $QUERY;
    global $ID;
    global $LANG_DW00;
    global $_CONF;
    global $_DW_CONF;

    if (!file_exists($_CONF['path_html'] . $_DW_CONF['public_dir'] . 'data/meta/_dokuwiki.changes') ) {
		return $LANG_DW00['no_whats_new'] . '<br />';
    }

    $count = 0;
    $cutoff = time() - (86400 * $_DW_CONF['whats_new_days']);

    require_once(DOKU_INC.'inc/init.php');
    require_once(DOKU_INC.'inc/common.php');
    require_once(DOKU_INC.'inc/events.php');
    require_once(DOKU_INC.'inc/pageutils.php');
    require_once(DOKU_INC.'inc/html.php');
    require_once(DOKU_INC.'inc/auth.php');
    require_once(DOKU_INC.'inc/actions.php');
    require_once(DOKU_INC.'inc/changelog.php');

    if ( !isset($_DW_CONF['whatsnew_length']) || $_DW_CONF['whatsnew_length'] == 0 ) {
        $_DW_CONF['whatsnew_length'] = 20;
    }

    $recent = array();
    $items  = array();
    $recent = getRecents(0,20,'',0);
    foreach ($recent as $item => $stuff) {
        if ( $stuff['date'] > $cutoff ) {
            $items[] = '<a href="' . $_CONF['site_url'] . $_DW_CONF['public_dir'] . 'doku.php?id=' . $stuff['id'] . '" title="' . $stuff['id'] . '">' . COM_truncate($stuff['id'],$_DW_CONF['whatsnew_length'],'') . '</a>';
            $count++;
        }
    }
    if ( $count == 0 ) {
        return $LANG_DW00['no_whats_new'] .  '<br />';
    }
    return $items;
}



/**
* Returns the administrative option for this plugin
*
* Adds the plugin to the Admin menu
*
* Universal Plugin:  Modify/Uncomment use it
*
* @return   array   Array containing (plugin name, plugin admin url, # of items in plugin or '')
*
*/
function plugin_getadminoption_dokuwiki() {
    global $_CONF, $_DW_CONF;

    if (SEC_inGroup('Root')) {
        return array('DokuWiki',$_CONF['site_url'] . $_DW_CONF['public_dir'] . 'doku.php?do=admin&amp;id=start','');
    }
}

function plugin_getmenuitems_dokuwiki() {
    global $_CONF, $_DW_CONF,$_USER,$LANG_DW00;

    if ( (!isset($_USER['uid']) || $_USER['uid'] < 2) && $_DW_CONF['loginrequired'] == 1 )  {
        return '';
    }

    if ($_DW_CONF['restrict_to_group'] != '' ) {
        if (SEC_inGroup($_DW_CONF['restrict_to_group'])) {
            $menuitems[$LANG_DW00['menulabel']] = $_CONF['site_url'] . $_DW_CONF['public_dir'] . 'doku.php';
            return $menuitems;
        }
    } else {
        $menuitems[$LANG_DW00['menulabel']] = $_CONF['site_url'] . $_DW_CONF['public_dir'] . 'doku.php';
        return $menuitems;
    }
    return '';
}


function plugin_searchtypes_dokuwiki() {
    global $_CONF, $_DW_CONF, $_USER, $LANG_DW00;

    if ( (!isset($_USER['uid']) || $_USER['uid'] < 2) && $_DW_CONF['loginrequired'] == 1 )  {
        return '';
    }
    if ($_DW_CONF['restrict_to_group'] != '' ) {
        if (!SEC_inGroup($_DW_CONF['restrict_to_group'])) {
            return '';
        }
    }

    $tmp['dokuwiki'] = $LANG_DW00['menulabel'];
    return $tmp;
}


/**
* this searches for pages matching the user query and returns an array of
* for the header and table rows back to search.php where it will be formated and
* printed
*
* @query            string          Keywords user is looking for
* @datestart        date/time       Start date to get results for
* @dateend          date/time       End date to get results for
* @topic            string          The topic they were searching in
* @type             string          Type of items they are searching
* @author           string          Get all results by this author
*
*/

function plugin_dopluginsearch_dokuwiki($query, $datestart, $dateend, $topic, $type, $author) {
    global $conf;
    global $QUERY;
    global $ID;
    global $LANG_DW00;
    global $_CONF;
    global $_DW_CONF;
    global $_USER;

    if ( $_DW_CONF['disable_search_integration'] == 1) {
        return '';
    }
    if ( (!isset($_USER['uid']) || $_USER['uid'] < 2) && $_DW_CONF['loginrequired'] == 1 )  {
        return '';
    }
    if ($_DW_CONF['restrict_to_group'] != '' ) {
        if (!SEC_inGroup($_DW_CONF['restrict_to_group'])) {
            return '';
        }
    }

    require_once(DOKU_INC.'inc/init.php');
    require_once(DOKU_INC.'inc/common.php');
    require_once(DOKU_INC.'inc/events.php');
    require_once(DOKU_INC.'inc/pageutils.php');
    require_once(DOKU_INC.'inc/html.php');
    require_once(DOKU_INC.'inc/auth.php');
    require_once(DOKU_INC.'inc/actions.php');
    require_once($_CONF['path_html'] . $_DW_CONF['public_dir'] . 'inc/search.php');
    require_once($_CONF['path_html'] . $_DW_CONF['public_dir'] . 'inc/fulltext.php');

    if (empty($type)) {
        $type = 'all';
    }

    // Bail if we aren't supppose to do our search
    if ($type <> 'all' AND $type <> 'dokuwiki') {
        $plugin_results = new Plugin();
        $plugin_results->plugin_name = 'dokuwiki';
        $plugin_results->searchlabel = 'DokuWiki Search Results';
        return $plugin_results;
    }

    $QUERY = addslashes($query);

    // OK, now create new plugin object and insert table header labels
    require_once($_CONF['path_system'] . 'classes/plugin.class.php');
    $plugin_results = new Plugin();
    $plugin_results->plugin_name = 'dokuwiki';
    $plugin_results->searchlabel = 'Wiki Search Results';
    $plugin_results->addSearchHeading('Wiki Page');

    $retval = '';

    $retval = p_locale_xhtml('searchpage');

    //check if search is restricted to namespace
    if(preg_match('/([^@]*)@([^@]*)/',$QUERY,$match)) {
        $id = cleanID($match[1]);
        if(empty($id)) {
            $retval .= '<div>'.$LANG_DW00['no_search_results'].'</div>';
            return $retval;
        }
    } else {
        $id = cleanID($QUERY);
    }

    //do quick pagesearch
    $data = array();
    //do fulltext search
    $data = ft_pageSearch($QUERY,$poswords);
    if(count($data)){
        $num = 0;
        foreach($data as $id => $cnt){
            $url = '<a href="' . $_CONF['site_url'] . $_DW_CONF['public_dir'] . 'doku.php?id=' . $id . '&amp;s=' . $query . '">' . $id . '</a>';
            $row = array($url);
            $plugin_results->addSearchResult($row);
            $num++;
        }
    } else {
        $retval .= '<div>'.$LANG_DW00['no_search_results'].'</div>';
    }

    $plugin_results->num_searchresults = $num;

    return $plugin_results;
}

function plugin_autotags_dokuwiki ($op, $content = '', $autotag = '') {
    global $_CONF, $_DW_CONF;

    if ($op == 'tagname' ) {
        return array('wiki');
    } else if ($op == 'parse') {
        $dwId = $autotag['parm1'];
        $caption = $autotag['parm2'];

        $link = '<a href="' . $_CONF['site_url'] . $_DW_CONF['public_dir'] . 'doku.php?id=' . $dwId . '">';
        if ( empty($caption) || $caption == '' ) {
            $caption = $dwId;
        }
        $dwTag = $link . $caption . '</a>';
        $content = str_replace ($autotag['tagstr'], $dwTag, $content);
        return $content;
    }
}



function plugin_chkVersion_dokuwiki() {
    global $_DW_CONF;

    return $_DW_CONF['version'];
}

function plugin_upgrade_dokuwiki()
{
    global $_TABLES, $_CONF, $_DW_CONF;

    $currentVersion = DB_getItem($_TABLES['plugins'],'pi_version',"pi_name='dokuwiki'");

    DB_query("UPDATE {$_TABLES['plugins']} SET pi_version='" . $_DW_CONF['version'] . "' WHERE pi_name='dokuwiki'");

    if ( DB_getItem($_TABLES['plugins'],'pi_version',"pi_name='dokuwiki'") == $_DW_CONF['version']) {
        return 1;
    } else {
        return 3;
    }
}

/**
* Removes the data structures for this plugin from the geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled.
*
* For this plugin, this routine will also remove the Block definition.
*
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Defult is blank but if set, check if plugin is disabled first
*
* @return   boolean True if successful false otherwise
*
*/
function plugin_uninstall_dokuwiki($installCheck='') {
    global $_DB_table_prefix, $_TABLES;

    $pi_name    = 'dokuwiki';

    // Check and see if plugin is still enabled - if so display warning and exit
    if ($installCheck != '' && DB_getItem($_TABLES['plugins'],'pi_enabled', 'pi_name = "' .$pi_name. '"')) {
        COM_errorLog("Plugin is installed and enabled. Disable first if you want to de-install it",1);
        $display .= COM_startBlock('Warning');
        $display .= 'DokuWiki Plugin is enabled';
        $display .= COM_endBlock();
        echo $display;
        return false;
        exit;
    }

    // Ok to proceed and delete plugin

    // Unregister the plugin with geeklog
    COM_errorLog('Attempting to unregister the dokuwiki Plugin from geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'dokuwiki'",1);

    COM_errorLog('...success',1);
    return true;
}
?>