<?php
/**
 * DokuWiki mainscript
 *
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Andreas Gohr <andi@splitbrain.org>
 */

//  xdebug_start_profiling();

  if(!defined('DOKU_INC')) define('DOKU_INC',dirname(__FILE__).'/');
  require_once(DOKU_INC.'inc/init.php');
  require_once(DOKU_INC.'inc/common.php');
  require_once(DOKU_INC.'inc/events.php');
  require_once(DOKU_INC.'inc/pageutils.php');
  require_once(DOKU_INC.'inc/html.php');
  require_once(DOKU_INC.'inc/auth.php');
  require_once(DOKU_INC.'inc/actions.php');

  if ( (!isset($_USER['uid']) || $_USER['uid'] < 2) && $_DW_CONF['loginrequired'] == 1 )  {
    $display = COM_siteHeader();
    $display .= COM_startBlock ($LANG_LOGIN[1], '',
                  COM_getBlockTemplate ('_generic_block', 'header'));
    $login = new Template($_CONF['path_layout'] . 'submit');
    $login->set_file (array ('login'=>'submitloginrequired.thtml'));
    $login->set_var ('login_message', $LANG_LOGIN[2]);
    $login->set_var ('site_url', $_CONF['site_url']);
    $login->set_var ('lang_login', $LANG_LOGIN[3]);
    $login->set_var ('lang_newuser', $LANG_LOGIN[4]);
    $login->parse ('output', 'login');
    $display .= $login->finish ($login->get_var('output'));
    $display .= COM_endBlock (COM_getBlockTemplate ('_generic_block', 'footer'));
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
  }
  if ($_DW_CONF['restrict_to_group'] != '' ) {
    if (!SEC_inGroup($_DW_CONF['restrict_to_group'])) {
        COM_errorLog("Someone has tried to illegally access the DokuWiki install/uninstall page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
        $display = COM_siteHeader ('menu', $LANG_404[1]);
        $display .= COM_startBlock ($LANG_404[1]);
        if (isset ($_SERVER['SCRIPT_URI'])) {
            $url = strip_tags ($_SERVER['SCRIPT_URI']);
        } else {
            $pos = strpos ($_SERVER['REQUEST_URI'], '?');
            if ($pos === false) {
                $request = $_SERVER['REQUEST_URI'];
            } else {
                $request = substr ($_SERVER['REQUEST_URI'], 0, $pos);
            }
            $url = 'http://' . $_SERVER['HTTP_HOST'] . strip_tags ($request);
        }
        $display .= sprintf ($LANG_404[2], $url);
        $display .= $LANG_404[3];
        $display .= COM_endBlock ();
        $display .= COM_siteFooter ();

        echo $display;
        exit;
    }
  }

  //import variables
  $QUERY = trim($_REQUEST['id']);
  $ID    = getID();
  $NS    = getNS($ID);
  $REV   = $_REQUEST['rev'];
  $ACT   = $_REQUEST['do'];
  $IDX   = $_REQUEST['idx'];
  $DATE  = $_REQUEST['date'];
  $RANGE = $_REQUEST['lines'];
  $HIGH  = $_REQUEST['s'];
  if(empty($HIGH)) $HIGH = getGoogleQuery();

  $TEXT  = cleanText($_POST['wikitext']);
  $PRE   = cleanText($_POST['prefix']);
  $SUF   = cleanText($_POST['suffix']);
  $SUM   = $_REQUEST['summary'];

  //sanitize revision
  $REV = preg_replace('/[^0-9]/','',$REV);

  //we accept the do param as HTTP header, too:
  if(!empty($_SERVER['HTTP_X_DOKUWIKI_DO'])){
    $ACT = trim(strtolower($_SERVER['HTTP_X_DOKUWIKI_DO']));
  }

  if(!empty($IDX)) $ACT='index';
  //set default #FIXME not needed here? done in actions?
  if(empty($ACT)) $ACT = 'show';

  //make infos about the selected page available
  $INFO = pageinfo();

  // handle debugging
  if($conf['allowdebug'] && $ACT == 'debug'){
    html_debug();
    exit;
  }

  //send 404 for missing pages if configured
  if($conf['send404'] &&
     ($ACT == 'show' || substr($ACT,0,7) == 'export_') &&
     !$INFO['exists']){
    header('HTTP/1.0 404 Not Found');
  }

  //prepare breadcrumbs (initialize a static var)
  breadcrumbs();

  // check upstream
  checkUpdateMessages();

  trigger_event('DOKUWIKI_STARTED',$tmp=array());

  //close session
  session_write_close();

  //do the work
  act_dispatch($ACT);

  trigger_event('DOKUWIKI_DONE', $tmp=array());

//  xdebug_dump_function_profile(1);
?>
