<?php
/**
 * Geeklog authentication backend
 *
 * @license   GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author    Andreas Gohr <andi@splitbrain.org>
 * @author    Mark R. Evans <mevans@ecsnet.com>
 */

class auth_geeklog extends auth_basic {
    var $cnf = null;

    /**
     * Constructor
     */
    function auth_geeklog(){
        global $conf;

        $this->cando['external'] = true;
        $this->cando['logoff']   = true;
        $this->success = true;
        return true;
    }

  /**
   * Just checks against the $pun_user variable
   */
  function trustExternal($user,$pass,$sticky=false){
    global $_USER;
    global $USERINFO;
    global $conf;
    global $lang;
    $sticky ? $sticky = true : $sticky = false; //sanity check

    if ( $_USER['uid'] > 1 ) {
       $USERINFO['pass'] = rand();
       $USERINFO['name'] = $_USER['username'];
       $USERINFO['mail'] = 'unknown';
       $USERINFO['grps'] = array();

       $grps = SEC_getUserGroups();
       $i = 0;
       foreach ($grps as $name=>$id) {
          $gName = preg_replace("/\s/e" , "" , $name);
          $gName2 = preg_replace("/-/","",$gName);
          $USERINFO['grps'][$i] = $gName2;
	  	  $i++;
       }
      $_SERVER['REMOTE_USER'] = $_USER['username'];
      $_SESSION[$conf['title']]['auth']['user'] = $_USER['username'];
      $_SESSION[$conf['title']]['auth']['info'] = $USERINFO;

      return true;
    } else {
      $USERINFO['name'] = 'Guest';
      $USERINFO['pass'] = rand();
      $USERINFO['mail'] = 'unknown';
      $USERINFO['grps'] = array();
      $USERINFO['grps'][0] = 'AllUsers';
      $USERINFO['grps'][1] = 'ALL';

      $_SERVER['REMOTE_USER'] ='Guest'; 
      $_SESSION[$conf['title']]['auth']['user'] = 'Guest';
      $_SESSION[$conf['title']]['auth']['info'] = $USERINFO;
      return true;
    }
  }

  function logOff(){
      $_SERVER['REMOTE_USER'] ='Guest';
      $_SESSION[$conf['title']]['auth']['user'] = 'Guest';
      $_SESSION[$conf['title']]['auth']['info'] = $USERINFO;
  }


}

//Setup VIM: ex: et ts=4 enc=utf-8 :
?>