<?php

/**

 * functions for mmClean Template

 *

 * License: GPL 2 (http://www.gnu.org/licenses/gpl.html)

 *

 * @author:   Marcin Mierzejewski <marcin@mierzejewski.net>

 * @homepage: http://www.mierzejewski.net

 */



require_once('conf.php');

 

/**

 * Displays the topbar

 *

 * @author: Marcin Mierzejewski <marcin@mierzejewski.net>

 */

function tpl_topbar() 

{

    global $conf, $ID, $REV, $INFO;

    $svID = $ID;

    $svREV = $REV;

    print p_wiki_xhtml("topbar", '', false);

    

    if ( $INFO['perm'] > AUTH_READ )

    {

        print '<ul><li><a href="?id=topbar&amp;do=edit" class="wikilink1" title="Edit Topbar">Edit Topbar</a></li></ul>';

    }

    

    $ID = $svID;

    $REV = $svREV;

}



/**

 * Displays the bottombar

 *

 * @author: Marcin Mierzejewski <marcin@mierzejewski.net>

 */

function tpl_bottombar() 

{

    global $INFO,$ID,$lang;

    $perm = $INFO['perm'];

   

    echo '<a href="?do=recent" class="interwiki" title="'.$lang['btn_rec'].'">'.$lang['btn_recent'].'</a>'

        .'&nbsp;&middot;&nbsp;';

    

    if($perm > AUTH_READ) {

        echo '<a href="?do=revisions" class="interwiki" title="'.$lang['btn_revs'].'">'.$lang['btn_revs'].'</a>'

            .'&nbsp;&middot;&nbsp;';

        if(file_exists(wikiFN($ID))) {

            echo '<a href="?id='.$ID.'&amp;do=edit" class="interwiki" title="'.$lang['btn_edit'].'">'.$lang['btn_edit'].'</a>';

        } else {

            echo '<a href="?id='.$ID.'&amp;do=edit" class="interwiki" title="'.$lang['btn_create'].'">'.$lang['btn_create'].'</a>';

        }

        echo '&nbsp;&middot;&nbsp;';

    } else {

        echo '<a href="?id='.$ID.'&amp;do=edit" class="interwiki" title="'.$lang['btn_source'].'">'.$lang['btn_source'].'</a>'

            .'&nbsp;&middot;&nbsp;';

    }



    if($perm > AUTH_WRITE) {

        echo '<a href="?do=admin" class="interwiki" title="'.$lang['btn_admin'].'">'.$lang['btn_admin'].'</a>'

            .'&nbsp;&middot;&nbsp;';

    }



    if(isset($INFO['userinfo']['name'])) {

        echo '<a href="?do=logout" class="interwiki" title="'.$lang['btn_logout'].'">'.$lang['btn_logout'].'</a>';

    } else {

        echo '<a href="?do=login" class="interwiki" title="'.$lang['btn_login'].'">'.$lang['btn_login'].'</a>';

    }

}



/**

 * Displays the sidebar

 *

 * @author: Marcin Mierzejewski <marcin@mierzejewski.net>

 */

function tpl_sidebar() 

{

    global $conf, $ID, $REV, $INFO, $lang;

    $currID = false;



		if ( true == $conf['tpl_mmClean']['sidebarPermanent'] && true == file_exists( (wikiFN("sidebar") ) ) )

		{

			print p_wiki_xhtml("sidebar", '', false);

			return;

		}



    // Remember $ID and $REV

    $svID = $ID;

    $svREV = $REV;



    // Parent side ID

    $sub = substr($ID, 0, strpos($ID, ":"));

    

    if ( file_exists(wikiFN($ID."/sidebar")) )

    {

        print "<h1>";

        print tpl_pagetitle();

        print "</h1>";

        print p_wiki_xhtml($ID."/sidebar", '', false);

				if ( $INFO['perm'] > AUTH_READ )

				{

						print '<ul><li><a href="?id='.$ID.':sidebar&amp;do=edit" class="wikilink1" title="Edit Sidebar"><b>Edit Sidebar</b></a></li></ul>';

				}

        $currID = $ID;

    }

    else if ( file_exists(wikiFN($sub."/sidebar")) )

    {

        print "<h1>";

        print tpl_pagetitle($sub);

        print "</h1>";

        print p_wiki_xhtml($sub."/sidebar", '', false);

				if ( $INFO['perm'] > AUTH_READ )

				{

						print '<ul><li><a href="?id='.$sub.':sidebar&amp;do=edit" class="wikilink1" title="Edit Sidebar"><b>Edit Sidebar</b></a></li></ul>';

				}

        $currID = $sub;

    }

    

    $ID = $svID;

    $REV = $svREV;

}



/**

 * Check if sidebar is present for this page

 *

 * @author:  Marcin Mierzejewski <marcin@mierzejewski.net>

 */

function tpl_issidebar()

{

    global $conf, $ID, $REV, $INFO, $ACT;



    if ( $ACT == 'edit' || $ACT == 'preview' )

        return false;



		// Permanent Sidebar

		if ( true == $conf['tpl_mmClean']['sidebarPermanent'] && true == file_exists( (wikiFN("sidebar") ) ) )

		{

			return true;	

		}



    $svID = $ID;

    $svREV = $REV;

    $sub = substr($ID, 0, strpos($ID, ":"));

    if (  file_exists(wikiFN($ID."/sidebar")) 

        ||file_exists(wikiFN($sub."/sidebar"))  

       )

        return true;

    else

        return false;

}



?>

